(function(){
	var epicocc = window.epicocc = (window.epicocc || {});
	
	function find_address_component(components, component_name){
		for(var i in components){
			var component = components[i];
			var component_types = component.types;//.join(',');
			for(var j in component_types){
				if( component_types[j] == component_name )
					return component;
			}
		}
		return false;
	}
	
	//
	// GEO CODDER
	var geocoder = new google.maps.Geocoder();
	epicocc.findAddresByZipCode = function(zip_code, complete_callback){
		//
		// fisrt search step ( find lat lng )
		geocoder.geocode({address:  zip_code}, function(locations){
			//
			// second search step ( find street name )
			var location = locations[0];
			if(!location) return complete_callback(false);
			geocoder.geocode({address: location.geometry.location.lat() + ',' + location.geometry.location.lng() },function(locations){
				//
				// get stret name
				var location = locations[0];
				if(!location) return complete_callback(false);
				
				//
				// mk custom address format
				var route_component = find_address_component(location.address_components, 'route');
				var neighborhood_component = find_address_component(location.address_components, 'neighborhood');
				var adm_area_level_2_component = find_address_component(location.address_components, 'administrative_area_level_2');
				var adm_area_level_1_component = find_address_component(location.address_components, 'administrative_area_level_1');
				var country_component = find_address_component(location.address_components, 'country');
				
				
				complete_callback([
					route_component.long_name, 
					'[COMPLEMENT]',
					neighborhood_component.long_name, 
					adm_area_level_2_component.long_name, 
					adm_area_level_1_component.short_name, 
					country_component.long_name
				].join(', '));
			});
		});
	}
})();

//
//
//epicocc.findAddresByZipCode('04001-001', function(street_name){ console.log(street_name)});